/*
 * Copyright (C) 2004  Moritz Orbach <irom@apfelboymchen.homeunix.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#include <stdio.h>
#include <stdlib.h>

/* fr strerror und errno */
#include <errno.h>

#ifdef DEBUG
#include "memwatch.h"
#define malloc mmalloc
#define free mfree
#endif

unsigned int ballocated = 0;


unsigned int allocated(void)
{
	extern unsigned int ballocated;

	return(ballocated);
}

/* typischer name wre anscheinend `xmalloc' (info libc) */
void *getmem(int size)
{
	extern unsigned int ballocated;


	void *p;
	p = malloc(size);
	if (p == NULL) {

		perror("malloc");
		exit (2);
	}
	ballocated += size;
	return(p);
}

void freemem(void *pointer, int size)
{
	extern unsigned int ballocated;

	/* wie kann man bei free() fehler abfragen? */
	free(pointer);
	pointer = NULL;
	ballocated -= size;
	if (ballocated < 0) {
		printf("mehr speicher freigegeben als geholt?? PANIK!\n");
		exit(2);
	}
}
